*******************************************************************************
* Project:	ultraSTE
* Module:	bmp reader
* Code:		ultra
* Created:	11.04.2021
* Notes:	supports only unpacked and 8 bit pixel count!
* Modified:
* Changes:
*
* (c) 2021 cream
*******************************************************************************

;bmp header offsets
bmpType		equ	$0
bmpSize		equ	$2
bmpReserved	equ	$6
bmpOffBits	equ	$a

;bmp info header offsets
bmpISize	equ	$e
bmpWidth	equ	$12
bmpHeight	equ	$16
bmpUnused1	equ	$1a
bmpBitCount	equ	$1c		;only 8 supported
bmpPacked	equ	$1e		;only 0 supported
bmpColTable	equ	$36

*******************************************************************************
BmpCheck:
; some basic checks of the bmp. will do an illegal instruction in
; case something is wrong. check d0 for the error

; a0 -> data
	cmp.w	#'BM',bmpType(a0)
	beq.s	.bmpok1
	moveq	#-2,d0
	illegal
.bmpok1:
	cmp.b	#8,bmpBitCount(a0)
	beq.s	.bmpok2
	moveq	#-3,d0
	illegal
.bmpok2:
	tst	bmpPacked(a0)
	beq.s	.bmpok3
	moveq	#-4,d0
	illegal
.bmpok3:
	rts

*******************************************************************************
BmpGetRawData:
; gets the image data from the bmp
; a0 -> data
; a0 <- raw pic data

	bsr	BmpCheck
	moveq	#0,d0
	move.b	bmpOffBits+1(a0),d0
	lsl	#8,d0
	move.b	bmpOffBits(a0),d0
	lea	(a0,d0.w),a0
	rts

*******************************************************************************
BmpGetColorTable:
; gets the color table data from the bmp
; a0 -> data
; a0 <- raw pic data

	bsr	BmpCheck
	lea	bmpColTable(a0),a0
	rts
